



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Vivado与SDK的联合调试方法-使用ILA</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Vivado与SDK的联合调试方法-使用ILA</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 10:34:46 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>
<div><img referrerpolicy="no-referrer"src="http://xilinx.eetrend.com/files-eetrend-xilinx/imagecache/image600/blog/201709/11982-32479-vivado.jpg" /></div>
</div>
</div>
<p>首先介绍一下我的硬件平台：使用的开发板为米联客出的MIZ702，这个开发板与ZedBoard是兼容的。</p>
<p>Vivado硬件调试有几种手段：ILA（集成逻辑分析器Integrated Logic Analyzer）、VIO（虚拟I/O Virtual Input/Output）、Jtag-to-AXI等，本方法主要使用了ILA 。</p>
<p>本实验系统使用了两种调试手段：ILA和VIO，ILA的引入方式又用了两种，一种是标记Debug mark，一种是添加ILA_IP两种方式我认为是一致的。其中ILA-IP抓取的LED的寄存器的波形，而Debug mark标记的是接到一个自主IP的AXI总线系统的Block Design如下图</p>
<p><img referrerpolicy="no-referrer"src="http://xilinx.eetrend.com/files-eetrend-xilinx/blog/201709/11982-32469-20170918-1.jpg" /></p>
<p>联调步骤：<br />STEP1:在block design设计完系统硬件后，点击想要抓取波形的网络，右击选择mark debug，此时网络两端会显示一个Debug标识如下图，保存。</p>
<p><img referrerpolicy="no-referrer"src="http://xilinx.eetrend.com/files-eetrend-xilinx/blog/201709/11982-32470-20170918-2.jpg" /></p>
<p>还有另外一种方法：直接添加ILA ip，设置好抓取波形的个数与每组波形的位宽，连接自己想要观测的总线,在这里我抓取的波形是一组8位的寄存器，所控制的是8个LED灯。如下两图</p>
<p><img referrerpolicy="no-referrer"src="http://xilinx.eetrend.com/files-eetrend-xilinx/blog/201709/11982-32471-20170918-3.jpg" /></p>
<p><img referrerpolicy="no-referrer"src="http://xilinx.eetrend.com/files-eetrend-xilinx/blog/201709/11982-32472-20170918-4.jpg" /></p>
<p>我认为这两种方法没有区别<br />STEP2:对工程进行综合，综合完成后查看综合结果，可以看到下面的debug窗口中有未连接的Debug nets，点击Set up Debug并进行相关配置完成Debug nets的连接。完成后如下图所示：</p>
<p><img referrerpolicy="no-referrer"src="http://xilinx.eetrend.com/files-eetrend-xilinx/blog/201709/11982-32473-20170918-5.jpg" /></p>
<p>STEP3:保存工程，此时系统会重新生成约束文件，对现有的约束文件进行填充，打开约束文件进行Reload即可，然后生成bitstream并将硬件导入SDK，运行SDK。</p>
<p>STEP4:在SDK中新建自己的调试应用程序，我的演示程序为流水灯主函数代码如下：<br />#include "xparameters.h" /* Peripheral parameters */<br />#include "xgpio.h" /* GPIO data struct and APIs */<br />#include "xil_printf.h"<br />#include "xil_cache.h"</p>
<p>#define GPIO_BITWIDTH 8 /* This is the width of the GPIO */<br />#define GPIO_DEVICE_ID XPAR_AXI_GPIO_0_DEVICE_ID //device id<br />#define LED_DELAY 10000000 /* times delay*/<br />#define LED_MAX_BLINK 0x1 /* Number of times the LED Blinks */<br />#define LED_CHANNEL 1 /* GPIO channel*/<br />#define printf xil_printf /* A smaller footprint printf */<br />XGpio Gpio; /* The Instance of the GPIO Driver */<br />XGpio GpioOutput; /* The driver instance for GPIO Device configured as O/P */</p>
<p>int GpioMarquee (u16 DeviceId, u32 GpioWidth)<br />{<br />volatile int Delay;<br />u32 LedBit;<br />u32 LedLoop;<br />int Status;<br />/*<br />* Initialize the GPIO driver so that it's ready to use,<br />* specify the device ID that is generated in xparameters.h<br />*/<br />Status = XGpio_Initialize(&amp;GpioOutput, DeviceId);<br />if (Status != XST_SUCCESS) {<br />return XST_FAILURE;<br />}<br />//Set the direction for all signals to be outputs<br />XGpio_SetDataDirection(&amp;GpioOutput, LED_CHANNEL, 0x0);<br />// Set the GPIO outputs to low<br />XGpio_DiscreteWrite(&amp;GpioOutput, LED_CHANNEL, 0x0);<br />for (LedBit = 0x0; LedBit &lt; GpioWidth; LedBit++) {<br />for (LedLoop = 0; LedLoop &lt; LED_MAX_BLINK; LedLoop++) {<br />//Set the GPIO Output to High<br />XGpio_DiscreteWrite(&amp;GpioOutput, LED_CHANNEL,<br />1 &lt;&lt; LedBit);<br />//Wait a small amount of time so the LED is visible<br />for (Delay = 0; Delay &lt; LED_DELAY; Delay++);<br />//Clear the GPIO Output<br />XGpio_DiscreteClear(&amp;GpioOutput, LED_CHANNEL,<br />1 &lt;&lt; LedBit);<br />// Wait a small amount of time so the LED is visible<br />for (Delay = 0; Delay &lt; LED_DELAY; Delay++);<br />}<br />}<br />return XST_SUCCESS;<br />}<br />int main(void)<br />{//Application start<br />/* loop forever*/<br />while(1){<br />u32 status;<br />status = GpioMarquee (GPIO_DEVICE_ID,GPIO_BITWIDTH);<br />if (status == 0)<br />print("SUCESS!.\r\n");<br />else print("FAILED.\r\n");<br />}<br />return XST_SUCCESS;<br />}</p>
<p>然后常规方法进入软件调试界面，设置断点。（这里提醒一下，联合调试一定要在SDK下将比特流下载到FPGA中，而不要在vivado中下载比特流。Xilinx官方给出的解释是：由于使用PS端的时钟来接入ILA，所以要现在SDK中将比特流进行下载）</p>
<p>STEP5:在Vivado中连接目标板，此时进入硬件调试界面如图</p>
<p><img referrerpolicy="no-referrer"src="http://xilinx.eetrend.com/files-eetrend-xilinx/blog/201709/11982-32474-20170918-6.jpg" /></p>
<p>左边栏hardware会显示系统添加的硬件调试IP，我的硬件中手动加入了一个ila ip和vio ip也将一段总线标记了mark debug，标记了mark debug的总线，在进行set up debug的操作时系统会自动添加一个ila ip，左边栏显示了三个调试ip。</p>
<p>这里面大大小小有好多窗口一一介绍一下：<br />1、设置窗口，window data depth其实就是波形的分辨率，trigger position in window就是数据的触发在波形中显示的起始位置，设置了触发后才会有作用。</p>
<p><img referrerpolicy="no-referrer"src="http://xilinx.eetrend.com/files-eetrend-xilinx/blog/201709/11982-32475-20170918-7.jpg" /></p>
<p>2、触发设置窗口，可以设置触发信号，以及触发方式（上升沿、下降沿）等等。若在SDK中的命令执行一句的过程中FPGA有时序变化，且时序是相关的，比如说我的写操作，当write有上升沿的时候执行，对目标地址写操作数。这时候如果设置了触发信号为write，系统的时序显示就会随着write进行动作，且在触发位置处进行改变。这个功能我们可以进行一些总线的时序分析。ILA2中检测了AXI总线，我们就可以看到相关时序图。ILA1只是对一个寄存器进行了监视，只能看到他的值的变化而已。</p>
<p><img referrerpolicy="no-referrer"src="http://xilinx.eetrend.com/files-eetrend-xilinx/blog/201709/11982-32476-20170918-8.jpg" /></p>
<p>3、状态窗口：显示当前调试状态<br />4、调试波形窗口</p>
<p><img referrerpolicy="no-referrer"src="http://xilinx.eetrend.com/files-eetrend-xilinx/blog/201709/11982-32477-20170918-9.jpg" /></p>
<p><img referrerpolicy="no-referrer"src="http://xilinx.eetrend.com/files-eetrend-xilinx/blog/201709/11982-32478-0918.jpg" /></p>
<p>大家调试不必按照此硬件系统和软件来调试，完全可以在自己的系统中添加ILA-IP来对自己的系统进行调试</p>
<p>欢迎大家批评指正，也希望能与大家交流ZYNQ的学习经验。</p>
<p>参考文献：<br />1、嵌入式系统软硬件协同设计实战指南-基于Xilinx ZYNQ<br />2、ug936-vivado-tutorial-programming-debugging</p>
<p>本文转载自：<a href="http://blog.csdn.net/qq_34322603" rel="external nofollow noreferrer">qq_34322603的博客</a></p>
<div>
<div>
<ul><li><a href="http://xilinx.eetrend.com/tag/6772" rel="external nofollow noreferrer">MiZ702</a></li>

<li><a href="http://xilinx.eetrend.com/tag/2109" rel="external nofollow noreferrer">SDK</a></li>

<li><a href="http://xilinx.eetrend.com/tag/1521" rel="external nofollow noreferrer">Vivado</a></li></ul>
</div>
<ul><li><a href="http://xilinx.eetrend.com/blogs/%E9%BE%99%E9%AA%91%E5%A3%AB" rel="external nofollow noreferrer">龙骑士's blog</a></li>

<li>要发表评论，请先<a href="http://xilinx.eetrend.com/user/login?destination=comment%2Freply%2F11982%23comment-form" rel="external nofollow noreferrer">登录</a>&nbsp;或&nbsp;<a href="http://xilinx.eetrend.com/user/register?destination=comment%2Freply%2F11982%23comment-form" rel="external nofollow noreferrer">注册</a></li>

<li>3022 次点击</li></ul>
</div>
<div>转载：http://xilinx.eetrend.com/blog/11982</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390vo6j8.html">String字符串针对常量池的优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/39ryxnd8.html">C&plus;&plus;中的4个类型转换关键字</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93neyzq.html">生成模型（Generative）和判别模型（Discriminative）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oyn0lq.html">实例存储支持的AMI创建步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93rdeg9.html">Getting Started with Blocks</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k6ro5q.html">LOAD和PigStorage的一些测试例子 &lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gve179.html">&lpar;十&rpar;Linux 网络编程之ioctl函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kgvo69.html">&period;htaccess设置自定义出错页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyj672q.html">Visual Studio 2015 社区版&period;专业版&period;企业版&lbrack;含安装密钥Pro&amp;amp&semi;Ent&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnepyoq.html">简单学习：repo入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdezk579.html">01-07-01【Nhibernate &lpar;版本3&period;3&period;1&period;4000&rpar; 出入江湖】并发控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdek1g79.html">SQl函数的写法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydn232q.html">uva-10487 - Closest Sums</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd31pxq.html">phpMyAdmin 完整路径泄露漏洞3</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m6p6xq.html">2015第6周三ztree的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde63gx9.html">最长回文子串 &vert; 勇幸&vert;Thinking</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jmvgw8.html">centos 修改&sol;etc&sol;fstab后无法启动</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpk7n39.html">动易CMS - 添加自定义字段</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljxpg69.html">js验证input输入框（字母，数字，符号，中文）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2yrj0q.html">js实现颜色渐变</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwlvl5l9.html">VREP中的力触觉设备接口（CHAI3D）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jm1mkg9.html">Java邻接表表示加权有向图，附dijkstra最短路径算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7eo7ng9.html">Spring框架使用&lpar;控制反转&comma;依赖注入&comma;面向切面AOP&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2k5x7lq.html">Navicatmysql专版</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1lne09.html">mysql workbench图形化mysql管理工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjwo0xq.html">Unable to instantiate application com&period;txrj&period;sms&period;activity&period;TxrjApplication</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppw3j79.html">Maven实战&mdash;&mdash;常用Maven插件介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlv4l39.html">Redis 集群&lowbar;主从配置&lowbar;哨兵模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve271o9.html">SSM框架配置文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnvlk3q.html">hashCode和identityHashCode 的关系</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
